## cupt 2.10.4+nmu1

=== cpp/lib/CMakeLists.txt ===
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  -fvisibility=hidden")
include_directories(include)
include_directories(src)

add_library(libcupt SHARED
	./include/cupt/versionstring.hpp
	./include/cupt/fwd.hpp
	./include/cupt/system/worker.hpp
	./include/cupt/system/resolvers/native.hpp
	./include/cupt/system/resolver.hpp
	./include/cupt/system/snapshots.hpp
	./include/cupt/system/state.hpp
	./include/cupt/stringrange.hpp
	./include/cupt/download/method.hpp
	./include/cupt/download/methodfactory.hpp
	./include/cupt/download/progresses/console.hpp
	./include/cupt/download/manager.hpp
	./include/cupt/download/progress.hpp
	./include/cupt/download/uri.hpp
	./include/cupt/file.hpp
	./include/cupt/packagename.hpp
	./include/cupt/format2.hpp
	./include/cupt/common.hpp
	./include/cupt/config.hpp
	./include/cupt/cache/package.hpp
	./include/cupt/cache/version.hpp
	./include/cupt/cache/binaryversion.hpp
	./include/cupt/cache/binarypackage.hpp
	./include/cupt/cache/sourcepackage.hpp
	./include/cupt/cache/sourceversion.hpp
	./include/cupt/cache/releaseinfo.hpp
	./include/cupt/cache/relation.hpp
	./include/cupt/hashsums.hpp
	./include/cupt/range.hpp
	./include/cupt/cache.hpp
	./src/internal/common.cpp
	./src/internal/configparser.cpp
	./src/internal/nativeresolver/impl.cpp
	./src/internal/nativeresolver/solution.cpp
	./src/internal/nativeresolver/score.cpp
	./src/internal/nativeresolver/dependencygraph.cpp
	./src/internal/nativeresolver/decisionfailtree.cpp
	./src/internal/nativeresolver/autoremovalpossibility.cpp
	./src/internal/lock.cpp
	./src/internal/cacheimpl.cpp
	./src/internal/pininfo.cpp
	./src/internal/filesystem.cpp
	./src/internal/debdeltahelper.cpp
	./src/internal/tagparser.cpp
	./src/internal/worker/base.cpp
	./src/internal/worker/archives.cpp
	./src/internal/worker/dpkg.cpp
	./src/internal/worker/metadata.cpp
	./src/internal/worker/setupandpreview.cpp
	./src/internal/worker/packages.cpp
	./src/internal/worker/snapshots.cpp
	./src/internal/worker/temppath.cpp
	./src/internal/regex.cpp
	./src/internal/cachefiles.cpp
	./src/internal/logger.cpp
	./src/internal/pipe.cpp
	./src/internal/basepackageiterator.cpp
	./src/internal/indexofindex.cpp
	./src/internal/versionparse.cpp
	./src/internal/parse.hpp
	./src/internal/parse.tpp
	./src/config.cpp
	./src/cache.cpp
	./src/cache/relation.cpp
	./src/cache/binarypackage.cpp
	./src/cache/binaryversion.cpp
	./src/cache/sourcepackage.cpp
	./src/cache/sourceversion.cpp
	./src/cache/package.cpp
	./src/cache/version.cpp
	./src/system/state.cpp
	./src/system/resolver.cpp
	./src/system/resolvers/native.cpp
	./src/system/worker.cpp
	./src/system/snapshots.cpp
	./src/download/uri.cpp
	./src/download/manager.cpp
	./src/download/method.cpp
	./src/download/methodfactory.cpp
	./src/download/progress.cpp
	./src/download/progresses/console.cpp
	./src/common.cpp
	./src/common/compareversions.cpp
	./src/common/consumers.cpp
	./src/file.cpp
	./src/hashsums.cpp
	./src/versionstring.cpp
)
set_target_properties(libcupt PROPERTIES SOVERSION ${CUPT_SOVERSION} OUTPUT_NAME "cupt${CUPT_API_VERSION}")
target_link_libraries(libcupt dl rt gcrypt -Wl,--no-undefined)

install(TARGETS libcupt DESTINATION lib)
install(DIRECTORY include/ DESTINATION include)

=== debian/changelog ===
cupt (2.10.4+nmu1) unstable; urgency=medium

  * Non-maintainer upload.
  * cmakelists: Fix boost version check (Closes: #960381)
    Based on the patch from Ubuntu

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 07 Jun 2020 22:56:21 +0200

## cupt 2.10.4+nmu1build1

=== debian/changelog ===
cupt (2.10.4+nmu1build1) hirsute; urgency=medium

  * No-change rebuild for boost soname change.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 12 Dec 2020 13:05:05 +0100

=== debian/control ===
Source: cupt
Section: admin
Priority: optional
Build-Depends:
# build system
  debhelper (>= 9),
  cmake (>= 2.6),
  chrpath,
  gettext,
  bash-completion,
# runtime libraries
  libboost-program-options-dev (>= 1.42),
  libboost-dev (>= 1.42),
  libreadline-dev,
  libcurl4-gnutls-dev (>= 7.19.4),
  libgcrypt20-dev,
# documentation
  doxygen,
  txt2tags,
# test suite
  gpgv (>= 2),
  gnupg (>= 2),
  ed,
  libipc-run3-perl,
  liblist-moreutils-perl,
  libtest-dir-perl,
  libexpect-simple-perl,
  locales-all
Maintainer: Eugene V. Lyubimkin <jackyf@debian.org>
Homepage: https://wiki.debian.org/Cupt
Standards-Version: 4.1.3
Vcs-Git: https://github.com/jackyf/cupt.git
Vcs-Browser: https://github.com/jackyf/cupt/tree/master

Package: cupt-dbg
Section: debug
Priority: optional
Architecture: any
Depends: libcupt4-2 (= ${binary:Version}) | cupt (= ${binary:Version}) |
 libcupt4-2-downloadmethod-curl (= ${binary:Version}) |
 libcupt4-2-downloadmethod-wget (= ${binary:Version}),
 ${misc:Depends}
Description: flexible package manager -- debugging symbols
 This package contains gdb debugging symbols for the Cupt packages.

Package: libcupt4-2
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, libcupt-common (>= ${source:Version})
Breaks: dpkg (<< 1.17.11~), gpgv (<< 2~)
Recommends: libcupt4-2-downloadmethod-curl | libcupt4-2-downloadmethod-wget, bzip2, gpgv, ed
Suggests: cupt, lzma, xz-utils, debdelta (>= 0.31), dpkg-dev, dpkg-repack
Description: flexible package manager -- runtime library
 This is a Cupt library implementing high-level package manager for Debian and
 derivatives. It's written with flexibility and reliability in mind and uses
 dpkg as the back-end.
 .
 Provides:
  - parsing and manipulating configuration info;
  - parsing indexes metadata info;
  - version strings comparison;
  - inspection of the binary and source package' versions;
  - parsing and querying info about installed packages;
  - parsing and working with relations and relation expressions;
  - download manager and downloaders for some schemes;
  - problem resolver;
  - worker for modifying system state.
 .
 See also description of 'cupt' package for more information.

Package: libcupt-common
Architecture: all
Depends: ${misc:Depends}
Conflicts: libcupt2-0
Replaces: libcupt2-0
Description: flexible package manager -- runtime library (support files)
 This package provides architecture-independent support parts for Cupt library.
 .
 See also description of libcupt4-2 package.

Package: libcupt4-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, libcupt4-2 (= ${binary:Version})
Conflicts: libcupt2-dev, libcupt3-dev
Suggests: libcupt4-doc
Description: flexible package manager -- development files
 This package provides headers for Cupt library.
 .
 See also description of libcupt4-2 package.

Package: libcupt4-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: flexible package manager -- library documentation
 This package provides documentation for Cupt library.
 .
 See also description of libcupt4-2 package.

Package: cupt
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, libcupt4-2 (>= ${binary:Version})
Suggests: sensible-utils, libreadline7
Description: flexible package manager -- console interface
 This package provides a console interface to Cupt library, which implements
 high-level package manager for Debian and derivatives. Cupt is written with
 flexibility and reliability in mind and uses dpkg as the back-end.
 .
 Cupt uses the same APT infrastructure, e.g. index files, deb cache archive
 files, configuration files. It understands some of widely used APT options.
 .
 Some features:
  - strict full-case resolver;
  - resolver reasons tracking;
  - command-line and 'cupt::*' option name checker;
  - case-sensitive search;
  - pinning by source package name;
  - pinning by package groups using shell-like patterns;
  - configurable 'depends' and 'rdepends' subcommands;
  - 'satisfy' subcommand;
  - support of LZMA-compressed indexes;
  - source versions synchronization;
  - 'shell' subcommand (to get command history, search etc. working, install
    the package 'libreadline7');
  - integration with debdelta (to get it, install the package 'debdelta');
  - system snapshots (needs packages 'dpkg-dev' and 'dpkg-repack').
 .
 Its interface is mostly like apt-get/aptitude console interface.
 .
 Cupt has built-in support for APT repositories using the file:// or copy://
 URL schemas. For access to remote repositories using HTTP or FTP, install a
 download method such as libcupt4-2-downloadmethod-curl.

Package: libcupt4-2-downloadmethod-curl
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: flexible package manager -- libcurl download method
 This package provides http(s) and ftp download handlers for Cupt library
 using libcurl.
 .
 See also description of libcupt4-2 package.

Package: libcupt4-2-downloadmethod-wget
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, wget
Description: flexible package manager -- wget download method
 This package provides http(s) and ftp download handlers for Cupt library
 using wget.
 .
 See also description of libcupt4-2 package.

=== debian/rules ===
#!/usr/bin/make -f

ifeq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
	CMAKE_OPTIONS += -DCMAKE_BUILD_TYPE=RelWithDebInfo
else
	CMAKE_OPTIONS += -DCMAKE_BUILD_TYPE=Debug
endif

BUILD_DIRECTORY=b/

override_dh_auto_configure:
	dh_auto_configure -B${BUILD_DIRECTORY} -- $(CMAKE_OPTIONS)

override_dh_auto_install-arch:
	dh_auto_configure -B${BUILD_DIRECTORY} -- $(CMAKE_OPTIONS) -DLOCAL:bool=off
	dh_auto_install -B${BUILD_DIRECTORY}
	chrpath --delete $(CURDIR)/debian/tmp/usr/bin/cupt

override_dh_auto_install-indep:
	dh_auto_install -B${BUILD_DIRECTORY} -i
	install -m644 scripts/logrotate $(CURDIR)/debian/libcupt-common/etc/logrotate.d/cupt

override_dh_strip:
	dh_strip --dbg-package=cupt-dbg

%:
	dh $@ -B${BUILD_DIRECTORY} --parallel --with bash-completion

## cupt 2.10.4+nmu1build2

=== debian/changelog ===
cupt (2.10.4+nmu1build2) noble; urgency=medium

  * No-change rebuild for boost defaults change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 19 Dec 2023 15:48:12 +0100

## cupt 2.10.4+nmu2

=== doc/CMakeLists.txt ===
IF(NOT EXISTS /usr/bin/doxygen)
	message(FATAL_ERROR "missing doxygen")
ENDIF(NOT EXISTS /usr/bin/doxygen)

IF(NOT EXISTS /usr/bin/txt2tags)
	message(FATAL_ERROR "missing txt2tags")
ENDIF(NOT EXISTS /usr/bin/txt2tags)

set(ODIR "${CMAKE_CURRENT_BINARY_DIR}")
set(DOXYGEN_OUTPUT_DIRECTORY "${ODIR}/reference")
add_custom_command(
	OUTPUT doxygen-stamp
	MAIN_DEPENDENCY "reference/Doxyfile"
	DEPENDS libcupt
	WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/reference"

	COMMAND mkdir -p ${DOXYGEN_OUTPUT_DIRECTORY}
	COMMAND sh -c "( cat Doxyfile; echo \"OUTPUT_DIRECTORY=${DOXYGEN_OUTPUT_DIRECTORY}\" ) | doxygen -"
	COMMAND find ${DOXYGEN_OUTPUT_DIRECTORY} -name "*.js" -delete
	COMMAND touch ${ODIR}/doxygen-stamp

	VERBATIM
)

MACRO(CUPT_PROCESS_T2T)
	FOREACH(_name ${ARGN})
		set(T2T_SOURCE "${CMAKE_CURRENT_SOURCE_DIR}/${_name}.t2t")
		set(HTML_FILE_NAME ${_name}.html)
		set(MAN_FILE_NAME cupt_${_name}.7)
		add_custom_command(
			MAIN_DEPENDENCY ${T2T_SOURCE}
			OUTPUT ${_name}-stamp

			COMMAND txt2tags ARGS -t html -o ${HTML_FILE_NAME} ${T2T_SOURCE}
			COMMAND txt2tags ARGS -t man -o ${MAN_FILE_NAME} ${T2T_SOURCE}
			COMMAND touch ${_name}-stamp
		)
		install(FILES ${ODIR}/${HTML_FILE_NAME} ${ODIR}/${MAN_FILE_NAME} DESTINATION share/doc)
	ENDFOREACH(_name)
ENDMACRO(CUPT_PROCESS_T2T)

CUPT_PROCESS_T2T(tutorial functionalselectors)


function(process_pod _name _section)
	set(MAN_FILE "${_name}.${_section}")
	set(POD_FILE "${CMAKE_CURRENT_SOURCE_DIR}/${MAN_FILE}.pod")
	string(TOUPPER ${_name} UC_NAME)

	add_custom_command(
		MAIN_DEPENDENCY ${POD_FILE}
		OUTPUT ${MAN_FILE}
		COMMAND pod2man --utf8 --name ${UC_NAME} --section ${_section} ${POD_FILE} ${MAN_FILE}
	)

	list(APPEND POD_MANS ${MAN_FILE})
	set(POD_MANS ${POD_MANS} PARENT_SCOPE)

	install(FILES ${ODIR}/${MAN_FILE} DESTINATION share/doc)
endfunction()

process_pod(cupt 1)
process_pod(cupt.conf 5)
process_pod(cupt_vs_apt 5)


add_custom_target(doc ALL DEPENDS doxygen-stamp tutorial-stamp functionalselectors-stamp ${POD_MANS})

install(DIRECTORY examples DESTINATION share/doc/lib FILES_MATCHING PATTERN "*.cpp" PATTERN "*CMake*" EXCLUDE)
install(DIRECTORY ${ODIR}/reference/html DESTINATION share/doc/lib)
install(DIRECTORY ${ODIR}/reference/man DESTINATION share FILES_MATCHING PATTERN cupt*)

add_subdirectory(examples)

=== debian/changelog ===
cupt (2.10.4+nmu2) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1061989

 -- Michael Hudson-Doyle <mwhudson@debian.org>  Tue, 27 Feb 2024 23:18:16 +0000

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: cupt
 Section: admin
 Priority: optional
-Build-Depends:
+Build-Depends: dpkg-dev (>= 1.22.5),
 # build system
   debhelper (>= 9),
   cmake (>= 2.6),
@@ -36,18 +36,20 @@
 Section: debug
 Priority: optional
 Architecture: any
-Depends: libcupt4-2 (= ${binary:Version}) | cupt (= ${binary:Version}) |
+Depends: libcupt4-2t64 (= ${binary:Version}) | cupt (= ${binary:Version}) |
  libcupt4-2-downloadmethod-curl (= ${binary:Version}) |
  libcupt4-2-downloadmethod-wget (= ${binary:Version}),
  ${misc:Depends}
 Description: flexible package manager -- debugging symbols
  This package contains gdb debugging symbols for the Cupt packages.
 
-Package: libcupt4-2
+Package: libcupt4-2t64
+Provides: ${t64:Provides}
+Replaces: libcupt4-2
 Section: libs
 Architecture: any
 Depends: ${misc:Depends}, ${shlibs:Depends}, libcupt-common (>= ${source:Version})
-Breaks: dpkg (<< 1.17.11~), gpgv (<< 2~)
+Breaks: libcupt4-2 (<< ${source:Version}), dpkg (<< 1.17.11~), gpgv (<< 2~)
 Recommends: libcupt4-2-downloadmethod-curl | libcupt4-2-downloadmethod-wget, bzip2, gpgv, ed
 Suggests: cupt, lzma, xz-utils, debdelta (>= 0.31), dpkg-dev, dpkg-repack
 Description: flexible package manager -- runtime library
@@ -76,18 +78,18 @@
 Description: flexible package manager -- runtime library (support files)
  This package provides architecture-independent support parts for Cupt library.
  .
- See also description of libcupt4-2 package.
+ See also description of libcupt4-2t64 package.
 
 Package: libcupt4-dev
 Section: libdevel
 Architecture: any
-Depends: ${misc:Depends}, libcupt4-2 (= ${binary:Version})
+Depends: ${misc:Depends}, libcupt4-2t64 (= ${binary:Version})
 Conflicts: libcupt2-dev, libcupt3-dev
 Suggests: libcupt4-doc
 Description: flexible package manager -- development files
  This package provides headers for Cupt library.
  .
- See also description of libcupt4-2 package.
+ See also description of libcupt4-2t64 package.
 
 Package: libcupt4-doc
 Section: doc
@@ -96,11 +98,11 @@
 Description: flexible package manager -- library documentation
  This package provides documentation for Cupt library.
  .
- See also description of libcupt4-2 package.
+ See also description of libcupt4-2t64 package.
 
 Package: cupt
 Architecture: any
-Depends: ${misc:Depends}, ${shlibs:Depends}, libcupt4-2 (>= ${binary:Version})
+Depends: ${misc:Depends}, ${shlibs:Depends}, libcupt4-2t64 (>= ${binary:Version})
 Suggests: sensible-utils, libreadline7
 Description: flexible package manager -- console interface
  This package provides a console interface to Cupt library, which implements
@@ -139,7 +141,7 @@
  This package provides http(s) and ftp download handlers for Cupt library
  using libcurl.
  .
- See also description of libcupt4-2 package.
+ See also description of libcupt4-2t64 package.
 
 Package: libcupt4-2-downloadmethod-wget
 Architecture: any
@@ -148,4 +150,4 @@
  This package provides http(s) and ftp download handlers for Cupt library
  using wget.
  .
- See also description of libcupt4-2 package.
+ See also description of libcupt4-2t64 package.

## cupt 2.10.4+nmu2build2

=== cpp/CMakeLists.txt ===
IF(NOT EXISTS /usr/include/boost/xpressive/xpressive_dynamic.hpp)
	message(FATAL_ERROR "missing Boost.Xpressive library")
ENDIF()

IF(NOT EXISTS /usr/include/boost/program_options.hpp)
	message(FATAL_ERROR "missing Boost.ProgramOptions library")
ENDIF()

find_package(Boost 1.42.0)
IF(Boost_FOUND)
	IF(Boost_VERSION LESS 1.42)
		message(FATAL_ERROR "need Boost of version 1.42.0")
	ENDIF(Boost_VERSION LESS 1.42)
ELSE()
	message(FATAL_ERROR "missing Boost")
ENDIF()

IF(NOT EXISTS /usr/include/readline/readline.h)
	message(FATAL_ERROR "missing GNU Readline library")
ENDIF()

OPTION(LOCAL "is build local" ON)

include(flags.cmake)
include(version.cmake)

include_directories(.)

add_subdirectory(console)
add_subdirectory(lib)
add_subdirectory(downloadmethods)

=== cpp/console/CMakeLists.txt ===
include_directories(../lib/include)
add_executable(cupt.bin
	common.cpp
	common.hpp
	cupt.cpp
	cupt.hpp
	misc.cpp
	misc.hpp
	handlers.hpp
	handlers/search.cpp
	handlers/misc.cpp
	handlers/managepackages.cpp
	handlers/shell.cpp
	handlers/download.cpp
	handlers/snapshot.cpp
	handlers/why.cpp
	colorizer.cpp
	colorizer.hpp
	functionselectors.cpp
	functionselectors.hpp
	selectors.cpp
	selectors.hpp
)
set_property(TARGET cupt.bin PROPERTY OUTPUT_NAME cupt)
target_link_libraries(cupt.bin libcupt boost_program_options)

install(TARGETS cupt.bin DESTINATION bin)

=== debian/changelog ===
cupt (2.10.4+nmu2build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 00:50:09 +0000

cupt (2.10.4+nmu2build1) noble; urgency=medium

  * No-change rebuild against libcurl3t64-gnutls

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 16 Mar 2024 06:48:10 +0000

## cupt 2.10.4+nmu2build3

=== po/CMakeLists.txt ===
include(FindGettext)

# existing targets don't suit:
# GETTEXT_CREATE_TRANSLATIONS modifies .po-files during the build
# GETTEXT_PROCESS_POT_FILE deletes .po-files in the 'clean' target
# GETTEXT_PROCESS_PO_FILES is limited to a single language and cannot be issued
#   several times due to 'duplicate targets error'

MACRO(CUPT_PROCESS_PO)
	FOREACH(_lang ${ARGN})
		GET_FILENAME_COMPONENT(_absPoFile ${_lang}.po ABSOLUTE)
		SET(_moFile ${CMAKE_CURRENT_BINARY_DIR}/${_lang}.mo)

		ADD_CUSTOM_COMMAND(
			OUTPUT ${_moFile}
			COMMAND ${GETTEXT_MSGFMT_EXECUTABLE} -o ${_moFile} ${_absPoFile}
			DEPENDS ${_absPoFile}
		)

		INSTALL(FILES ${_moFile} DESTINATION share/locale/${_lang}/LC_MESSAGES RENAME cupt.mo)
		SET(_moFiles ${_moFiles} ${_moFile})
	ENDFOREACH(_lang)

	ADD_CUSTOM_TARGET(translations ALL DEPENDS ${_moFiles})
ENDMACRO(CUPT_PROCESS_PO)


CUPT_PROCESS_PO(pl da sk fr de)

=== doc/examples/show-available/CMakeLists.txt ===
add_executable(show-available show-available.cpp)
target_link_libraries(show-available libcupt)

=== debian/changelog ===
cupt (2.10.4+nmu2build3) questing; urgency=medium

  * No-change rebuild for boost 1.88.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 11 Aug 2025 08:25:51 +0200

## cupt 2.10.4+nmu2build4

=== debian/changelog ===
cupt (2.10.4+nmu2build4) resolute; urgency=medium

  * No-change rebuild for boost 1.90.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 04 Feb 2026 14:22:31 +0100
